// Package main generates banner.go
package main

import (
	"bytes"
	"fmt"
	"os"
	"os/exec"
	"strings"
	"time"
)

const banner = `// Code generated by kanban/gen. DO NOT EDIT.

package banner

// Version ...
var Version = "%s"

// Copyright ...
var Copyright = "© 2023 - %d FloatTech"

// Banner ...
var Banner = "* QQ + NanoBot + Golang\n" +
	"* Version " + Version + " - %s\n" +
	"* Copyright " + Copyright + ". All Rights Reserved.\n" +
	"* Project: https://github.com/FloatTech/NanoBot-Plugin"
`

const timeformat = `2006-01-02 15:04:05 +0900 JST`

func main() {
	f, err := os.Create("banner/banner.go")
	if err != nil {
		panic(err)
	}
	defer f.Close()
	vartag := bytes.NewBuffer(nil)
	vartagcmd := exec.Command("git", "tag", "--sort=committerdate")
	vartagcmd.Stdout = vartag
	err = vartagcmd.Run()
	if err != nil {
		panic(err)
	}
	s := strings.Split(vartag.String(), "\n")
	now := time.Now()
	_, err = fmt.Fprintf(f, banner, s[len(s)-2], now.Year(), now.Format(timeformat))
	if err != nil {
		panic(err)
	}
}
